#include "SoftwareSerial.h"
#include <LiquidCrystal.h>

LiquidCrystal lcd(7, 6, 5, 4, 3, 2);
SoftwareSerial mySerial(10, 11);

# define Start_Byte 0x7E
# define Version_Byte 0xFF
# define Command_Length 0x06
# define End_Byte 0xEF
# define Acknowledge 0x00 //Returns info with command 0x41 [0x01: info, 0x00: no info]
# define ACTIVATED LOW

int lectura_pinANA1;
int lectura_pinANA;
int pinANA1 = A1;
int pinANA = A0;
int VLM = 0;
int buttonNext = 8;
int buttonPause = 9;
int buttonVolUp = 12;
boolean isPlaying = false;

//Here we define all pins in the arduino




void setup () {
lcd.begin(16, 2);
pinMode(pinANA1, INPUT_PULLUP);
digitalWrite(pinANA1, HIGH);
pinMode(pinANA, INPUT_PULLUP);
digitalWrite(pinANA, HIGH);
pinMode(buttonPause, INPUT_PULLUP);
digitalWrite(buttonPause, HIGH);
pinMode(buttonNext, INPUT_PULLUP);
digitalWrite(buttonNext, HIGH);
pinMode(buttonVolUp, INPUT_PULLUP);
digitalWrite(buttonVolUp, HIGH);

//here set all the pins to the same value as the push buttons.

mySerial.begin (9600); //starts serial communication
delay(1000);

playFirst();
isPlaying = true;

Serial.begin(9600); //starts serial communication
}

void loop () //start a loop
{
lectura_pinANA1 = digitalRead(pinANA1);
lectura_pinANA = digitalRead(pinANA);
if (digitalRead(buttonPause) == ACTIVATED)
{
Serial.println("play"); // order the screen to give a message “play”
if (isPlaying)
{
pause();
isPlaying = false;
Serial.println("play false");
} else
{
isPlaying = true;
play();
Serial.println("play true");
}
}
if (digitalRead(buttonNext) == ACTIVATED)
{Serial.println("jaja");
if (isPlaying)
{


playNext();
}
}


if (digitalRead(buttonVolUp) == ACTIVATED)
{
if (isPlaying)
{
volumeUp(); }
}


if (lectura_pinANA == 0 )
{
volumeDO();
Serial.println("si");
}

if (lectura_pinANA1 == 0) {
playPrevious();
Serial.println("no");
}
}


void playFirst() //orders the song to start when the system is turned on
{
execute_CMD(0x3F, 0, 0);
delay(500);
setVolume(30);
delay(500);
execute_CMD(0x11, 0, 1);
delay(500);
}



void pause() //orders to stop the song
{
execute_CMD(0x0E, 0, 0);
delay(500);
lcd.setCursor(0, 1);
lcd.print("PAUSED ");
}


void play() //orders to start the song
{
execute_CMD(0x0D, 0, 1);
delay(500);
lcd.setCursor(0, 1);
lcd.print("PLAYING");
}


void playNext() // orders to skip to the next song
{
execute_CMD(0x01, 0, 1);
delay(500);
lcd.setCursor(8, 1);
lcd.print(" NEXT");
}



void playPrevious() // orders to go back the previous song
{
execute_CMD(0x02, 0, 1);
delay(500);
lcd.setCursor(8, 1);
lcd.print("PREVIOUS");
}


void setVolume(int volume) //stars the orders of the volume
{
execute_CMD(0x06, 0, volume); // Set the volume (0x00~0x30)
delay(200);
}


void volumeUp() //orders to level up the volume

{
VLM = VLM + 3;
setVolume(VLM);
Serial.print(VLM);
lcd.setCursor(9, 0);
lcd.print(" Vol. ");
delay(30);
lcd.setCursor(14, 0);
lcd.print(VLM);
if ( VLM >= 30 ) {
VLM = 30;
setVolume(VLM);
lcd.setCursor(9, 0);
lcd.print("Vol.MAX");
}
}



void volumeDO() //orders to level down the volume

{
VLM = VLM - 3;
setVolume(VLM);
lcd.setCursor(9, 0);
lcd.print(" Vol. ");
delay(30);
lcd.setCursor(14, 0);
lcd.print(VLM);
if (VLM <= 0) {
VLM = 0;
setVolume(VLM);
lcd.setCursor(9, 0);
lcd.print("Vol.MIN");
}
}



void execute_CMD(byte CMD, byte Par1, byte Par2)
// Excecute the command and parameters
{
// Calculate the checksum (2 bytes)
word checksum = -(Version_Byte + Command_Length + CMD + Acknowledge + Par1 + Par2);
// Build the command line
byte Command_line[10] = { Start_Byte, Version_Byte, Command_Length, CMD, Acknowledge,
Par1, Par2, highByte(checksum), lowByte(checksum), End_Byte
};
//Send the command line to the module
for (byte k = 0; k < 10; k++)
{
mySerial.write( Command_line[k]);
}
}
